<?php
/**
 * MarketplaceMyActionTag automatically generated by SDKgen please do not edit this file manually
 * @see https://sdkgen.app
 */

namespace Fusio\Marketplace;

use GuzzleHttp\Exception\BadResponseException;
use Sdkgen\Client\Exception\ClientException;
use Sdkgen\Client\Exception\Payload;
use Sdkgen\Client\Exception\UnknownStatusCodeException;
use Sdkgen\Client\TagAbstract;

class MarketplaceMyActionTag extends TagAbstract
{
    /**
     * Publish an action
     *
     * @param string $actionId
     * @param Passthru $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function publish(string $actionId, Passthru $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/action/:action_id/publish', [
            'action_id' => $actionId,
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Removes an action
     *
     * @param string $actionId
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function delete(string $actionId): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/action/:action_id', [
            'action_id' => $actionId,
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('DELETE', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Updates an action
     *
     * @param string $actionId
     * @param MarketplaceActionUpdate $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function update(string $actionId, MarketplaceActionUpdate $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/action/:action_id', [
            'action_id' => $actionId,
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('PUT', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Create a new action
     *
     * @param MarketplaceActionCreate $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function create(MarketplaceActionCreate $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/action', [
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Returns a specific action
     *
     * @param string $actionId
     * @return MarketplaceAction
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function get(string $actionId): MarketplaceAction
    {
        $url = $this->parser->url('/marketplace/my/action/:action_id', [
            'action_id' => $actionId,
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('GET', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceAction::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Returns all actions for the authenticated user
     *
     * @param int|null $startIndex
     * @param int|null $count
     * @param string|null $query
     * @return MarketplaceActionCollection
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function getAll(?int $startIndex = null, ?int $count = null, ?string $query = null): MarketplaceActionCollection
    {
        $url = $this->parser->url('/marketplace/my/action', [
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
                'startIndex' => $startIndex,
                'count' => $count,
                'query' => $query,
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('GET', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceActionCollection::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }



}
