<?php
/**
 * MarketplaceMyAppTag automatically generated by SDKgen please do not edit this file manually
 * @see https://sdkgen.app
 */

namespace Fusio\Marketplace;

use GuzzleHttp\Exception\BadResponseException;
use Sdkgen\Client\Exception\ClientException;
use Sdkgen\Client\Exception\Payload;
use Sdkgen\Client\Exception\UnknownStatusCodeException;
use Sdkgen\Client\TagAbstract;

class MarketplaceMyAppTag extends TagAbstract
{
    /**
     * Publish an app
     *
     * @param string $appId
     * @param Passthru $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function publish(string $appId, Passthru $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/app/:app_id/publish', [
            'app_id' => $appId,
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Removes an app
     *
     * @param string $appId
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function delete(string $appId): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/app/:app_id', [
            'app_id' => $appId,
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('DELETE', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Updates an app
     *
     * @param string $appId
     * @param MarketplaceAppUpdate $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function update(string $appId, MarketplaceAppUpdate $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/app/:app_id', [
            'app_id' => $appId,
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('PUT', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Create a new app
     *
     * @param MarketplaceAppCreate $payload
     * @return MarketplaceMessage
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function create(MarketplaceAppCreate $payload): MarketplaceMessage
    {
        $url = $this->parser->url('/marketplace/my/app', [
        ]);

        $options = [
            'headers' => [
                'Content-Type' => 'application/json',
            ],
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload,
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Returns a specific app
     *
     * @param string $appId
     * @return MarketplaceApp
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function get(string $appId): MarketplaceApp
    {
        $url = $this->parser->url('/marketplace/my/app/:app_id', [
            'app_id' => $appId,
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('GET', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceApp::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * Returns all apps for the authenticated user
     *
     * @param int|null $startIndex
     * @param int|null $count
     * @param string|null $query
     * @return MarketplaceAppCollection
     * @throws MarketplaceMessageException
     * @throws ClientException
     */
    public function getAll(?int $startIndex = null, ?int $count = null, ?string $query = null): MarketplaceAppCollection
    {
        $url = $this->parser->url('/marketplace/my/app', [
        ]);

        $options = [
            'headers' => [
            ],
            'query' => $this->parser->query([
                'startIndex' => $startIndex,
                'count' => $count,
                'query' => $query,
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('GET', $url, $options);
            $body = $response->getBody();

            $data = $this->parser->parse((string) $body, MarketplaceAppCollection::class);

            return $data;
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $body = $e->getResponse()->getBody();
            $statusCode = $e->getResponse()->getStatusCode();

            if ($statusCode === 400) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 404) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            if ($statusCode === 500) {
                $data = $this->parser->parse((string) $body, MarketplaceMessage::class);

                throw new MarketplaceMessageException($data);
            }

            throw new UnknownStatusCodeException('The server returned an unknown status code: ' . $statusCode);
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }



}
