<?php
/*
 * PSX is an open source PHP framework to develop RESTful APIs.
 * For the current version and information visit <https://phpsx.org>
 *
 * Copyright (c) Christoph Kappestein <christoph.kappestein@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

namespace PSX\Framework\Config;

/**
 * Directory
 *
 * @author  Christoph Kappestein <christoph.kappestein@gmail.com>
 * @license http://www.apache.org/licenses/LICENSE-2.0
 * @link    https://phpsx.org
 */
class Directory implements DirectoryInterface
{
    private string $appDir;
    private string $cacheDir;
    private string $srcDir;
    private string $logDir;

    public function __construct(string $appDir, string $cacheDir, string $srcDir, string $logDir)
    {
        $this->appDir = $appDir;
        $this->cacheDir = $cacheDir;
        $this->srcDir = $srcDir;
        $this->logDir = $logDir;
    }

    public function getAppDir(): string
    {
        return $this->appDir;
    }

    public function getCacheDir(): string
    {
        return $this->cacheDir;
    }

    public function getSrcDir(): string
    {
        return $this->srcDir;
    }

    public function getLogDir(): string
    {
        return $this->logDir;
    }
}
